diff -r 091f89c47ad9 trytond/modules/stock/shipment.py
--- a/trytond/modules/stock/shipment.py	Mon Sep 10 15:28:38 2012 +0200
+++ b/trytond/modules/stock/shipment.py	Mon Sep 24 20:36:42 2012 +0200
@@ -739,22 +728,19 @@
                     - qty_default_uom)
             else:
                 return False
-        self.assign(ids)
+        cls.assign(shipments)
         return True
 
+    @classmethod
     @ModelView.button
-    def assign_force(self, ids):
-        self.assign(ids)
-
-ShipmentInReturn()
+    def assign_force(cls, shipments):
+        cls.assign(shipments)
 
 
 class ShipmentOut(Workflow, ModelSQL, ModelView):
     "Customer Shipment"
-    _name = 'stock.shipment.out'
-    _description = __doc__
+    __name__ = 'stock.shipment.out'
     _rec_name = 'code'
-
     effective_date = fields.Date('Effective Date', readonly=True)
     planned_date = fields.Date('Planned Date',
         states={
@@ -777,7 +763,7 @@
         depends=['state', 'outgoing_moves'])
     customer_location = fields.Function(fields.Many2One('stock.location',
             'Customer Location', on_change_with=['customer']),
-        'get_customer_location')
+        'on_change_with_customer_location')
     delivery_address = fields.Many2One('party.address',
         'Delivery Address', required=True,
         states={
@@ -796,10 +782,10 @@
         depends=['state', 'outgoing_moves'])
     warehouse_storage = fields.Function(fields.Many2One('stock.location',
             'Warehouse Storage', on_change_with=['warehouse']),
-        'get_warehouse_storage')
+        'on_change_with_warehouse_storage')
     warehouse_output = fields.Function(fields.Many2One('stock.location',
             'Warehouse Output', on_change_with=['warehouse']),
-        'get_warehouse_output')
+        'on_change_with_warehouse_output')
     outgoing_moves = fields.Function(fields.One2Many('stock.move', None,
             'Outgoing Moves',
             domain=[
@@ -842,14 +828,15 @@
         ('waiting', 'Waiting'),
         ], 'State', readonly=True)
 
-    def __init__(self):
-        super(ShipmentOut, self).__init__()
-        self._order[0] = ('id', 'DESC')
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(ShipmentOut, cls).__setup__()
+        cls._order[0] = ('id', 'DESC')
+        cls._error_messages.update({
                 'delete_cancel': 'Customer Shipment "%s" must be cancelled '\
                     'before deletion!',
                 })
-        self._transitions |= set((
+        cls._transitions |= set((
                 ('draft', 'waiting'),
                 ('waiting', 'assigned'),
                 ('assigned', 'packed'),
@@ -863,7 +850,7 @@
                 ('packed', 'cancel'),
                 ('cancel', 'draft'),
                 ))
-        self._buttons.update({
+        cls._buttons.update({
                 'cancel': {
                     'invisible': Eval('state').in_(['cancel', 'done']),
                     },
@@ -896,14 +883,15 @@
                 'assign_force': {},
                 })
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migration from 1.2: packing renamed into shipment
         old_table = 'stock_packing_out'
         if TableHandler.table_exist(cursor, old_table):
-            TableHandler.table_rename(cursor, old_table, self._table)
+            TableHandler.table_rename(cursor, old_table, cls._table)
 
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         for field in ('create_uid', 'write_uid', 'delivery_address',
                 'warehouse', 'customer'):
             table.drop_fk(field, table=old_table)
@@ -913,181 +901,144 @@
         # Migration from 2.0:
         created_company = table.column_exist('company')
 
-        super(ShipmentOut, self).init(module_name)
+        super(ShipmentOut, cls).__register__(module_name)
 
         # Migration from 2.0:
-        move_obj = Pool().get('stock.move')
+        Move = Pool().get('stock.move')
         if (not created_company
-                and TableHandler.table_exist(cursor, move_obj._table)):
-            move_obj = Pool().get('stock.move')
+                and TableHandler.table_exist(cursor, Move._table)):
             cursor.execute('SELECT shipment.id, MAX(move.company) '
                 'FROM "%s" AS shipment '
                 'INNER JOIN "%s" AS move ON shipment.id = move.shipment_out '
                 'GROUP BY shipment.id '
                 'ORDER BY MAX(move.company)'
-                % (self._table, move_obj._table))
+                % (cls._table, Move._table))
             for company_id, values in itertools.groupby(cursor.fetchall(),
                     operator.itemgetter(1)):
                 shipment_ids = [x[0] for x in values]
                 for i in range(0, len(shipment_ids), cursor.IN_MAX):
                     sub_ids = shipment_ids[i:i + cursor.IN_MAX]
                     red_sql, red_ids = reduce_ids('id', sub_ids)
-                    cursor.execute('UPDATE "' + self._table + '" '
+                    cursor.execute('UPDATE "' + cls._table + '" '
                         'SET company = %s WHERE ' + red_sql,
                         [company_id] + red_ids)
             table.not_null_action('company', action='add')
 
         # Migration from 1.0 customer_location is no more used
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         table.drop_column('customer_location', exception=True)
 
         # Add index on create_date
         table.index_action('create_date', action='add')
 
-    def default_state(self):
+    @staticmethod
+    def default_state():
         return 'draft'
 
-    def default_warehouse(self):
-        location_obj = Pool().get('stock.location')
-        location_ids = location_obj.search(self.warehouse.domain)
-        if len(location_ids) == 1:
-            return location_ids[0]
+    @classmethod
+    def default_warehouse(cls):
+        Location = Pool().get('stock.location')
+        locations = Location.search(cls.warehouse.domain)
+        if len(locations) == 1:
+            return locations[0].id
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-    def on_change_customer(self, values):
-        if not values.get('customer'):
+    def on_change_customer(self):
+        if not self.customer:
             return {'delivery_address': None}
-        party_obj = Pool().get("party.party")
-        address_id = party_obj.address_get(values['customer'], type='delivery')
-        return {'delivery_address': address_id}
+        address = self.customer.address_get(type='delivery')
+        return {'delivery_address': address.id}
 
-    def on_change_with_customer_location(self, values):
-        pool = Pool()
-        party_obj = pool.get('party.party')
-        if values.get('customer'):
-            customer = party_obj.browse(values['customer'])
-            return customer.customer_location.id
+    def on_change_with_customer_location(self, name=None):
+        if self.customer:
+            return self.customer.customer_location.id
 
-    def get_customer_location(self, ids, name):
-        locations = {}
-        for shipment in self.browse(ids):
-            locations[shipment.id] = shipment.customer.customer_location.id
-        return locations
+    @classmethod
+    def default_warehouse_storage(cls):
+        warehouse = cls.default_warehouse()
+        if warehouse:
+            return cls(warehouse=warehouse).on_change_with_warehouse_storage()
 
-    def default_warehouse_storage(self):
-        warehouse = self.default_warehouse()
+    def on_change_with_warehouse_storage(self, name=None):
+        if self.warehouse:
+            return self.warehouse.storage_location.id
+
+    @classmethod
+    def default_warehouse_output(cls):
+        warehouse = cls.default_warehouse()
         if warehouse:
-            value = self.on_change_with_warehouse_storage({
-                    'warehouse': warehouse,
-                    })
-            return value
+            return cls(warehouse=warehouse).on_change_with_warehouse_output()
 
-    def on_change_with_warehouse_storage(self, values):
-        pool = Pool()
-        location_obj = pool.get('stock.location')
-        if values.get('warehouse'):
-            warehouse = location_obj.browse(values['warehouse'])
-            return warehouse.storage_location.id
+    def on_change_with_warehouse_output(self, name=None):
+        if self.warehouse:
+            return self.warehouse.output_location.id
 
-    def get_warehouse_storage(self, ids, name):
-        storages = {}
-        for shipment in self.browse(ids):
-            storages[shipment.id] = shipment.warehouse.storage_location.id
-        return storages
+    def get_outgoing_moves(self, name):
+        moves = []
+        for move in self.moves:
+            if move.from_location.id == self.warehouse.output_location.id:
+                moves.append(move.id)
+        return moves
 
-    def default_warehouse_output(self):
-        warehouse = self.default_warehouse()
-        if warehouse:
-            value = self.on_change_with_warehouse_output({
-                    'warehouse': warehouse,
-                    })
-            return value
-
-    def on_change_with_warehouse_output(self, values):
-        pool = Pool()
-        location_obj = pool.get('stock.location')
-        if values.get('warehouse'):
-            warehouse = location_obj.browse(values['warehouse'])
-            return warehouse.output_location.id
-
-    def get_warehouse_output(self, ids, name):
-        outputs = {}
-        for shipment in self.browse(ids):
-            outputs[shipment.id] = shipment.warehouse.output_location.id
-        return outputs
-
-    def get_outgoing_moves(self, ids, name):
-        res = {}
-        for shipment in self.browse(ids):
-            res[shipment.id] = []
-            for move in shipment.moves:
-                if move.from_location.id == \
-                        shipment.warehouse.output_location.id:
-                    res[shipment.id].append(move.id)
-        return res
-
-    def set_outgoing_moves(self, ids, name, value):
+    @classmethod
+    def set_outgoing_moves(cls, shipments, name, value):
         if not value:
             return
-        self.write(ids, {
-            'moves': value,
-            })
+        cls.write(shipments, {
+                'moves': value,
+                })
 
-    def get_inventory_moves(self, ids, name):
-        res = {}
-        for shipment in self.browse(ids):
-            res[shipment.id] = []
-            for move in shipment.moves:
-                if move.to_location.id == \
-                        shipment.warehouse.output_location.id:
-                    res[shipment.id].append(move.id)
-        return res
+    def get_inventory_moves(self, name):
+        moves = []
+        for move in self.moves:
+            if move.to_location.id == self.warehouse.output_location.id:
+                moves.append(move.id)
+        return moves
 
-    def set_inventory_moves(self, ids, name, value):
+    @classmethod
+    def set_inventory_moves(cls, shipments, name, value):
         if not value:
             return
-        self.write(ids, {
-            'moves': value,
-            })
+        cls.write(shipments, {
+                'moves': value,
+                })
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('draft')
-    def draft(self, ids):
-        move_obj = Pool().get('stock.move')
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments
+    def draft(cls, shipments):
+        Move = Pool().get('stock.move')
+        Move.write([m for s in shipments
                 for m in s.inventory_moves + s.outgoing_moves
                 if m.state not in ('draft', 'done')], {
                 'state': 'draft',
                 })
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('waiting')
-    def wait(self, ids):
+    def wait(cls, shipments):
         """
         Complete inventory moves to match the products and quantities
         that are in the outgoing moves.
         """
-        move_obj = Pool().get('stock.move')
+        Move = Pool().get('stock.move')
 
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments for m in s.inventory_moves
+        Move.write([m for s in shipments for m in s.inventory_moves
                 if m.state not in ('draft', 'done')], {
                 'state': 'draft',
                 })
-        move_obj.delete([m.id for s in shipments for m in s.inventory_moves
+        Move.delete([m for s in shipments for m in s.inventory_moves
                 if m.state in ('draft', 'cancel')])
 
-        # Re-Browse because moves have been deleted
-        shipments = self.browse(ids)
-
         for shipment in shipments:
             for move in shipment.outgoing_moves:
                 if move.state in ('cancel', 'done'):
                     continue
-                move_obj.create({
+                Move.create({
                         'from_location': \
                             move.shipment_out.warehouse.storage_location.id,
                         'to_location': move.from_location.id,
@@ -1102,17 +1053,19 @@
                         'unit_price': move.unit_price,
                         })
 
+    @classmethod
     @Workflow.transition('assigned')
-    def assign(self, ids):
+    def assign(cls, shipments):
         pass
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('packed')
-    def pack(self, ids):
-        move_obj = Pool().get('stock.move')
-        uom_obj = Pool().get('product.uom')
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments for m in s.inventory_moves
+    def pack(cls, shipments):
+        pool = Pool()
+        Move = pool.get('stock.move')
+        Uom = pool.get('product.uom')
+        Move.write([m for s in shipments for m in s.inventory_moves
                 if m.state not in ('done', 'cancel')], {
                 'state': 'done',
                 })
@@ -1123,7 +1076,7 @@
             for move in shipment.outgoing_moves:
                 if move.state == 'cancel':
                     continue
-                quantity = uom_obj.compute_qty(move.uom, move.quantity,
+                quantity = Uom.compute_qty(move.uom, move.quantity,
                         move.product.default_uom, round=False)
                 outgoing_qty.setdefault(move.product.id, 0.0)
                 outgoing_qty[move.product.id] += quantity
@@ -1131,7 +1084,7 @@
             for move in shipment.inventory_moves:
                 if move.state == 'cancel':
                     continue
-                qty_default_uom = uom_obj.compute_qty(move.uom, move.quantity,
+                qty_default_uom = Uom.compute_qty(move.uom, move.quantity,
                     move.product.default_uom, round=False)
                 # Check if the outgoing move doesn't exist already
                 if outgoing_qty.get(move.product.id):
@@ -1143,15 +1096,15 @@
                     else:
                         out_quantity = (qty_default_uom
                             - outgoing_qty[move.product.id])
-                        out_quantity = uom_obj.compute_qty(
+                        out_quantity = Uom.compute_qty(
                             move.product.default_uom, out_quantity, move.uom)
                         outgoing_qty[move.product.id] = 0.0
                 else:
                     out_quantity = move.quantity
 
-                unit_price = uom_obj.compute_price(move.product.default_uom,
+                unit_price = Uom.compute_price(move.product.default_uom,
                         move.product.list_price, move.uom)
-                move_obj.create({
+                Move.create({
                         'from_location': move.to_location.id,
                         'to_location': shipment.customer.customer_location.id,
                         'product': move.product.id,
@@ -1170,152 +1123,152 @@
                 if move.state == 'cancel':
                     continue
                 if outgoing_qty.get(move.product.id, 0.0) > 0.0:
-                    exc_qty = uom_obj.compute_qty(move.product.default_uom,
+                    exc_qty = Uom.compute_qty(move.product.default_uom,
                             outgoing_qty[move.product.id], move.uom)
-                    removed_qty = uom_obj.compute_qty(move.uom,
+                    removed_qty = Uom.compute_qty(move.uom,
                         min(exc_qty, move.quantity), move.product.default_uom,
                         round=False)
-                    move_obj.write(move.id, {
+                    Move.write([move], {
                             'quantity': max(0.0, move.quantity - exc_qty),
                             })
                     outgoing_qty[move.product.id] -= removed_qty
 
-        move_obj.write([m.id for s in shipments for m in s.outgoing_moves
+        Move.write([m for s in shipments for m in s.outgoing_moves
                 if m.state not in ('cancel', 'done')], {
                 'state': 'assigned',
                 })
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('done')
-    def done(self, ids):
-        move_obj = Pool().get('stock.move')
-        date_obj = Pool().get('ir.date')
+    def done(cls, shipments):
+        pool = Pool()
+        Move = pool.get('stock.move')
+        Date = pool.get('ir.date')
 
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments for m in s.outgoing_moves
+        Move.write([m for s in shipments for m in s.outgoing_moves
                 if m.state not in ('done', 'cancel')], {
                 'state': 'done',
                 })
-        self.write(ids, {
-                'effective_date': date_obj.today(),
+        cls.write(shipments, {
+                'effective_date': Date.today(),
                 })
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('cancel')
-    def cancel(self, ids):
-        move_obj = Pool().get('stock.move')
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments
+    def cancel(cls, shipments):
+        Move = Pool().get('stock.move')
+        Move.write([m for s in shipments
                 for m in s.outgoing_moves + s.inventory_moves
                 if m.state not in ('cancel', 'done')], {
                 'state': 'cancel',
                 })
 
-    def _get_move_planned_date(self, shipment):
+    @property
+    def _move_planned_date(self):
         '''
         Return the planned date for outgoing moves and inventory moves
         '''
-        return shipment.planned_date, shipment.planned_date
+        return self.planned_date, self.planned_date
 
-    def _set_move_planned_date(self, shipment_ids):
+    @classmethod
+    def _set_move_planned_date(self, shipments):
         '''
         Set planned date of moves for the shipments
         '''
-        move_obj = Pool().get('stock.move')
-        if isinstance(shipment_ids, (int, long)):
-            shipment_ids = [shipment_ids]
-        for shipment in self.browse(shipment_ids):
-            dates = self._get_move_planned_date(shipment)
-            outgoing_date, inventory_date = dates
-            move_obj.write([x.id for x in shipment.outgoing_moves
+        Move = Pool().get('stock.move')
+        for shipment in shipments:
+            outgoing_date, inventory_date = shipment._move_planned_date
+            Move.write([x for x in shipment.outgoing_moves
                     if x.state not in ('assigned', 'done', 'cancel')], {
                     'planned_date': outgoing_date,
                     })
-            move_obj.write([x.id for x in shipment.inventory_moves
+            Move.write([x for x in shipment.inventory_moves
                     if x.state not in ('assigned', 'done', 'cancel')], {
                     'planned_date': inventory_date,
                     })
 
-    def create(self, values):
-        sequence_obj = Pool().get('ir.sequence')
-        config_obj = Pool().get('stock.configuration')
+    @classmethod
+    def create(cls, values):
+        pool = Pool()
+        Sequence = pool.get('ir.sequence')
+        Config = pool.get('stock.configuration')
 
         values = values.copy()
-        config = config_obj.browse(1)
-        values['code'] = sequence_obj.get_id(config.shipment_out_sequence.id)
-        shipment_id = super(ShipmentOut, self).create(values)
-        self._set_move_planned_date(shipment_id)
-        return shipment_id
+        config = Config(1)
+        values['code'] = Sequence.get_id(config.shipment_out_sequence.id)
+        shipment = super(ShipmentOut, cls).create(values)
+        cls._set_move_planned_date([shipment])
+        return shipment
 
-    def write(self, ids, values):
-        result = super(ShipmentOut, self).write(ids, values)
-        self._set_move_planned_date(ids)
-        return result
+    @classmethod
+    def write(cls, shipments, values):
+        super(ShipmentOut, cls).write(shipments, values)
+        cls._set_move_planned_date(shipments)
 
-    def copy(self, ids, default=None):
+    @classmethod
+    def copy(cls, shipments, default=None):
         if default is None:
             default = {}
         default = default.copy()
         default['inventory_moves'] = None
         default['outgoing_moves'] = None
-        return super(ShipmentOut, self).copy(ids, default=default)
+        return super(ShipmentOut, cls).copy(shipments, default=default)
 
-    def delete(self, ids):
-        if isinstance(ids, (int, long)):
-            ids = [ids]
+    @classmethod
+    def delete(cls, shipments):
         # Cancel before delete
-        self.cancel(ids)
-        for shipment in self.browse(ids):
+        cls.cancel(shipments)
+        for shipment in shipments:
             if shipment.state != 'cancel':
-                self.raise_user_error('delete_cancel', shipment.rec_name)
-        return super(ShipmentOut, self).delete(ids)
+                cls.raise_user_error('delete_cancel', shipment.rec_name)
+        super(ShipmentOut, cls).delete(shipments)
 
-    def _location_amount(self, target_uom, qty_uom, uom_index):
+    @staticmethod
+    def _location_amount(target_uom, qty_uom, uom_index):
         """
         Take a raw list of quantities and uom and convert it to
         the target uom.
         """
-        uom_obj = Pool().get('product.uom')
+        Uom = Pool().get('product.uom')
         res = 0
         for uom, qty in qty_uom:
-            res += uom_obj.compute_qty(uom_index[uom], qty,
+            res += Uom.compute_qty(uom_index[uom], qty,
                     uom_index[target_uom])
         return res
 
+    @classmethod
     @ModelView.button_action('stock.wizard_shipment_out_assign')
-    def assign_wizard(self, ids):
+    def assign_wizard(cls, shipments):
         pass
 
+    @classmethod
     @ModelView.button
-    def assign_try(self, ids):
-        move_obj = Pool().get('stock.move')
-        shipments = self.browse(ids)
-        if move_obj.assign_try([m for s in shipments
+    def assign_try(cls, shipments):
+        Move = Pool().get('stock.move')
+        if Move.assign_try([m for s in shipments
                     for m in s.inventory_moves]):
-            self.assign(ids)
+            cls.assign(shipments)
             return True
         else:
             return False
 
+    @classmethod
     @ModelView.button
-    def assign_force(self, ids):
-        move_obj = Pool().get('stock.move')
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments for m in s.inventory_moves
+    def assign_force(cls, shipments):
+        Move = Pool().get('stock.move')
+        Move.write([m for s in shipments for m in s.inventory_moves
                 if m.state not in ('cancel', 'done')], {
                 'state': 'assigned',
                 })
-        self.assign(ids)
-
-ShipmentOut()
+        cls.assign(shipments)
 
 
 class ShipmentOutReturn(Workflow, ModelSQL, ModelView):
     "Customer Return Shipment"
-    _name = 'stock.shipment.out.return'
-    _description = __doc__
+    __name__ = 'stock.shipment.out.return'
     _rec_name = 'code'
-
     effective_date = fields.Date('Effective Date', readonly=True)
     planned_date = fields.Date('Planned Date',
         states={
@@ -1338,7 +1291,7 @@
         depends=['state', 'incoming_moves'])
     customer_location = fields.Function(fields.Many2One('stock.location',
             'Customer Location', on_change_with=['customer']),
-        'get_customer_location')
+        'on_change_with_customer_location')
     delivery_address = fields.Many2One('party.address',
         'Delivery Address', required=True,
         states={
@@ -1357,10 +1310,10 @@
         depends=['state', 'incoming_moves'])
     warehouse_storage = fields.Function(fields.Many2One('stock.location',
             'Warehouse Storage', on_change_with=['warehouse']),
-        'get_warehouse_storage')
+        'on_change_with_warehouse_storage')
     warehouse_input = fields.Function(fields.Many2One('stock.location',
             'Warehouse Input', on_change_with=['warehouse']),
-        'get_warehouse_input')
+        'on_change_with_warehouse_input')
     incoming_moves = fields.Function(fields.One2Many('stock.move', None,
             'Incoming Moves',
             domain=[
@@ -1400,14 +1353,15 @@
         ('received', 'Received'),
         ], 'State', readonly=True)
 
-    def __init__(self):
-        super(ShipmentOutReturn, self).__init__()
-        self._order[0] = ('id', 'DESC')
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(ShipmentOutReturn, cls).__setup__()
+        cls._order[0] = ('id', 'DESC')
+        cls._error_messages.update({
                 'delete_cancel': 'Customer Return Shipment "%s" must be '\
                     'cancelled before deletion!',
                 })
-        self._transitions |= set((
+        cls._transitions |= set((
                 ('draft', 'received'),
                 ('received', 'done'),
                 ('received', 'draf'),
@@ -1415,7 +1369,7 @@
                 ('received', 'cancel'),
                 ('cancel', 'draft'),
                 ))
-        self._buttons.update({
+        cls._buttons.update({
                 'cancel': {
                     'invisible': Eval('state').in_(['cancel', 'done']),
                     },
@@ -1430,14 +1384,15 @@
                     },
                 })
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migration from 1.2: packing renamed into shipment
         old_table = 'stock_packing_out_return'
         if TableHandler.table_exist(cursor, old_table):
-            TableHandler.table_rename(cursor, old_table, self._table)
+            TableHandler.table_rename(cursor, old_table, cls._table)
 
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         for field in ('create_uid', 'write_uid', 'delivery_address',
                 'warehouse', 'customer'):
             table.drop_fk(field, table=old_table)
